#include <stdio.h>
//#include <stdlib.h>
#include <string.h>



#define DATA_WIDTH	176
#define DATA_HEIGHT	32
#define DATA_SIZE	(DATA_WIDTH*DATA_HEIGHT)
#define DATA_BLK_HEIGHT	(DATA_HEIGHT>>2)
#define DATA_BLK_WIDTH	(DATA_WIDTH>>2)
#define DATA_BLK_NUM	(DATA_SIZE>>4)

unsigned short compute_block_average(unsigned short* blk_buff) {

	short blk_average=0;
	short sum=0;
	char i;
	for(i=16; i!=0; i--) {
		sum += *blk_buff;
		blk_buff++;
	}
	blk_average = sum >> 4;
	return blk_average;
}

	unsigned short data_array[DATA_SIZE];
	unsigned short blk_buff[16];			// 4x4 temp block	
	
int main(void)
{
	
	unsigned short *pdata_array = data_array;
	unsigned short blk_average[DATA_BLK_NUM];
	unsigned short blk_cnt=0;
	unsigned short *pblk = blk_buff;
	unsigned short *pdata_array_tmp = data_array;	//pointer for computation
	short i;
	char iblk_Y, iblk_X, row;
	short curr_offset_inblk = 0;
	short curr_row_inblk = 0;
	short curr_col_inblk = 0;
	short curr_blk=0;
	short curr_blk_row=0;
	short curr_blk_col=0;
	short blk_base_data=0;

	//==== Initialize the data values in the memory
	printf("Write to memory in sequential manner\n");
	for(i=(DATA_SIZE-1);i!=0;i--)
		data_array[i]=i%65535;
	data_array[0]=0;
	
	
	//===== Store in sequential manner ====	
	printf("Memory Access Example\n");
	
	for(iblk_Y = DATA_BLK_HEIGHT;iblk_Y != 0;iblk_Y--) {
		for(iblk_X = DATA_BLK_WIDTH;iblk_X != 0;iblk_X--) {
			for(row = 4; row != 0; row--) {	//copy from data_array into blk_buff
				memcpy(pblk, pdata_array_tmp, 4*sizeof(unsigned short));
				pblk += 4;
				pdata_array_tmp += DATA_WIDTH;	// block access pattern due to sequential data storage
			}
			//- update pointers to next block
			pdata_array += 4;
			pblk=blk_buff;
			pdata_array_tmp = pdata_array;
			//- computblock
			blk_average[blk_cnt] = compute_block_average(blk_buff);
			blk_cnt++;
		}
		pdata_array += DATA_WIDTH*3;	// next block row
	}
	
	printf("blk_average[0]= %d\n\n\n", blk_average[0]);	
	
	
	printf("Write to memory in block tile manner\n");
	//===== Store in block tile manner ====
	for(i=0; i<DATA_SIZE;i++) {
		curr_offset_inblk = i%16;
		curr_row_inblk = curr_offset_inblk/4;
		curr_col_inblk = curr_offset_inblk%4;
		curr_blk = (i/16);
		curr_blk_row = (curr_blk/DATA_BLK_WIDTH);
		curr_blk_col = (curr_blk%DATA_BLK_WIDTH);
		blk_base_data = (curr_blk_row*4*DATA_WIDTH+curr_blk_col*4);
		blk_base_data = (curr_blk_row*4*DATA_WIDTH+curr_blk_col*4);
		data_array[i] = blk_base_data+curr_row_inblk*DATA_WIDTH+curr_col_inblk;

	}
	
	//- reset pointers
	pdata_array = data_array;
	pblk = blk_buff;
	pdata_array_tmp = data_array;	//pointer for computation
	blk_cnt=0;
	
	for(iblk_Y = DATA_BLK_HEIGHT;iblk_Y != 0;iblk_Y--) {
		for(iblk_X = DATA_BLK_WIDTH;iblk_X != 0;iblk_X--) {
			memcpy(pblk, pdata_array_tmp, 16*sizeof(unsigned short));
			pdata_array_tmp +=16;	// block access pattern due to block storage
			//- update pointers to next block
			//pdata_array += 16;		//no need!!
			pblk=blk_buff;
			//pdata_array_tmp = pdata_array;	//no_need!!
			//- computblock
			blk_average[blk_cnt] = compute_block_average(blk_buff);
			blk_cnt++;
		}
		//pdata_array += DATA_WIDTH*3;	// next block row no_need!!
	}

	printf("blk_average[0]= %d\n\n\n", blk_average[0]);	
	
  return 0;
}

